#!/bin/sh
count=$1
generator=$2
repack='git gc'
copy='rsync -avPq'
if [ -z "$count" -o -z "$generator" ]; then
	echo "Usage: $0 COUNT GENERATOR-SCRIPT" 1>&2
	exit 1
fi

dirname_1=$(basename $generator)-pass1-generate
dirname_2=$(basename $generator)-pass2-repack
dirname_3=$(basename $generator)-pass3-rebase
dirname_4=$(basename $generator)-pass4-repack

scripts="$generator make-data.sh"
mkdir $dirname_1
cp -f $scripts $dirname_1
pushd $dirname_1
git init
git add $scripts
git config gc.pruneExpire '1 second'
git commit -m 'Initial commit.' $scripts
./$generator $1
popd

$copy $dirname_1/ $dirname_2/
pushd $dirname_2
$repack
popd

$copy $dirname_2/ $dirname_3/
cat >rebase-cmd.sh <<EOF
#!/bin/bash
cat \$1 >../rebase.input
sed -i '1s,^pick,p,;s/^pick/fixup/g;' \$1
cat \$1 >../rebase.output
EOF
chmod +x rebase-cmd.sh
pushd $dirname_3
topcommit=$(git log | awk '/^commit/{print $2}' |tail -n1)
GIT_SEQUENCE_EDITOR="`pwd`/../rebase-cmd.sh" git rebase -i $topcommit
popd

$copy $dirname_3/ $dirname_4/
pushd $dirname_4
$repack
popd

du --max-depth=1 --bytes |grep git
